#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <err.h>
#include <sys/select.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int main(int argc, char * argv[]) {
    int sock;
    struct sockaddr_in server;
    unsigned char message[1000] ;
    unsigned char server_reply[2000];
    //Create socket
    sock = socket(AF_INET, SOCK_STREAM, 0);

    if (sock == -1) {
        printf("Could not create socket");
    }

    puts("Socket created");
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    server.sin_family = AF_INET;
    server.sin_port = htons( 9000 );

    //Connect to remote server
    if (connect(sock, (struct sockaddr *)&server, sizeof(server)) < 0) {
        perror("connect failed. Error");
        return 1;
    }

    puts("Connected\n");
    unsigned char sendlines[9][36] = {
        {0x78, 0x78, 0x11, 0x1, 0x3, 0x57, 0x59, 0x11, 0x0, 0x12, 0x57, 0x12, 0x80, 0x6, 0x6, 0x41, 0x0, 0x37, 0xab, 0x9f, 0xd, 0xa},
        {0x78, 0x78, 0x1F, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xCC, 0x00, 0x26, 0x6A, 0x00, 0x1F, 0x40, 0x00, 0x02, 0x27, 0x69, 0x0D, 0x0A},
        {0x78, 0x78, 0x08, 0x13, 0x10, 0x06, 0x04, 0x00, 0x03, 0xB2, 0x71, 0x0D, 0x0A},
        {0x78, 0x78, 0x1F, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xCC, 0x00, 0x26, 0x6A, 0x00, 0x1F, 0x40, 0x00, 0x04, 0x42, 0x5F, 0x0D, 0x0A},
        {0x78, 0x78, 0x1F, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xCC, 0x00, 0x26, 0x6A, 0x00, 0x1F, 0x40, 0x00, 0x05, 0x53, 0xD6, 0x0D, 0x0A},
        {0x78, 0x78, 0x1F, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xCC, 0x00, 0x26, 0x6A, 0x00, 0x1F, 0x40, 0x00, 0x06, 0x61, 0x4D, 0x0D, 0x0A},
        {0x78, 0x78, 0x08, 0x13, 0x10, 0x06, 0x04, 0x00, 0x0D, 0x5B, 0x0F, 0x0D, 0x0A},
        {0x78, 0x78, 0x08, 0x13, 0x10, 0x06, 0x04, 0x00, 0x0E, 0x69, 0x94, 0x0D, 0x0A},
        {0x78, 0x78, 0x08, 0x13, 0x10, 0x06, 0x04, 0x00, 0x0F, 0x78, 0x1D, 0x0D, 0x0A}
    };
    unsigned char sendlen[] = {22, 36, 13, 36, 36, 36, 13, 13, 13};
    unsigned char recvlen[] = {10, 0, 10, 0, 0, 0, 10, 10, 10};
    unsigned char recvlines[9][10] = {
        {0x78, 0x78, 0x5, 0x1, 0x0, 0x37, 0x8d, 0x69, 0xd, 0xa},
        {},
        {0x78, 0x78, 0x05, 0x13, 0x00, 0x03, 0xCA, 0xE3, 0x0D, 0x0A},
        {},
        {},
        {},
        {0x78, 0x78, 0x05, 0x13, 0x00, 0x0D, 0x23, 0x9D, 0x0D, 0x0A},
        {0x78, 0x78, 0x05, 0x13, 0x00, 0x0E, 0x11, 0x06, 0x0D, 0x0A},
        {0x78, 0x78, 0x05, 0x13, 0x00, 0x0F, 0x00, 0x8F, 0x0D, 0x0A}
    };

    for (int i = 0; i < 9; i++) {
        //Send some data
        fprintf(stdout, "sending data: ");

        for (int n = 0; n < sendlen[i]; n++) {
            fprintf(stdout, "%x ", sendlines[i][n]);
        }

        fprintf(stdout, "\n");

        if ( send(sock, sendlines[i], sendlen[i], 0) < 0) {
            fprintf(stdout, "bla\n");
            fprintf(stdout, "send failed for message: %u \n", i);
            return -1;
        }

        sleep(1);

        //Receive a reply from the server
        if (recvlen[i] > 0) {
            fprintf(stdout, "recieving response for message %u \n", i);

            if ( recv(sock, server_reply, recvlen[i], 0) < 0) {
                fprintf(stdout, "recv failed for message: %u \n", i);
                return -1;
            }

            if (memcmp(recvlines[i], server_reply, recvlen[i]) != 0) {
                fprintf(stdout, "recv invalid response for message %u :", i);

                for (int n = 0; n < recvlen[i]; n++) {
                    fprintf(stdout, "%x ", server_reply[n]);
                }

                fprintf(stdout, "\n");
                return -1;
            }
        }
    }

    close(sock);
    return 0;
}

