#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <err.h>
#include <sys/select.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int main(int argc, char * argv[]) {
    int sock;
    struct sockaddr_in server;
    unsigned char message[1000] ;
    unsigned char server_reply[2000];
    //Create socket
    sock = socket(AF_INET, SOCK_STREAM, 0);

    if (sock == -1) {
        printf("Could not create socket");
    }

    puts("Socket created");
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    server.sin_family = AF_INET;
    server.sin_port = htons( 8999 );

    //Connect to remote server
    if (connect(sock, (struct sockaddr *)&server, sizeof(server)) < 0) {
        perror("connect failed. Error");
        return 1;
    }

    puts("Connected\n");
    unsigned char sendlines[9][512] = {
        "0470$MGV002,860719020193193,DeviceName,R,240214,104742,A,2238.20471,N,11401.97967,E,00,03,00,1.20,0.462,356.23,137.9,1.5,460,07,262C,0F54,25, ,,,,, 28.5,28.3,,10,100,Timer, 18339df945d0:53|108c0fb0a2f1:57|e46f133d6f5c:59|108ccf109f21:59|8adc963d752a:82|04c5a48cc6c0:82|9adc963d752a:83|8800b0b00004:85|90671c80e2fc:85|80c5e68c8d36:86,460:00:262c:0f8e:40|460:00:262c:0f5b:31|460:00:262c:10f7:30|460:00:262c:0f47:29|460:00:262c:0f79:28|460:00:262c:1073:27|460:00:27ba:0f5c:25;!"
    };
    unsigned char recvlen[] = {0};
    unsigned char recvlines[9][10] = {{}};

    for (int i = 0; i < 9; i++) {
        //Send some data
        fprintf(stdout, "sending data: ");

        if ( send(sock, sendlines[i], strlen(sendlines[i]), 0) < 0) {
            fprintf(stdout, "send failed for message: %u \n", i);
            return -1;
        }

        sleep(1);

        //Receive a reply from the server
        if (recvlen[i] > 0) {
            fprintf(stdout, "recieving response for message %u \n", i);

            if ( recv(sock, server_reply, recvlen[i], 0) < 0) {
                fprintf(stdout, "recv failed for message: %u \n", i);
                return -1;
            }

            if (memcmp(recvlines[i], server_reply, recvlen[i]) != 0) {
                fprintf(stdout, "recv invalid response for message %u :", i);

                for (int n = 0; n < recvlen[i]; n++) {
                    fprintf(stdout, "%x ", server_reply[n]);
                }

                fprintf(stdout, "\n");
                return -1;
            }
        }
    }

    close(sock);
    return 0;
}

